#include <C8051F300.h>
#include <stdio.h>

#define V_REF 3

#define BIT4 0x01 << 4
#define BIT5 0x01 << 5
#define BIT7 0x01 << 7

unsigned char volt;

void main(void)
{
/* disable to watchdog timer 
  EA = 0;
  WDTCN = 0xDE;
  WDTCN = 0xAD;
  EA = 1;*/

/* setup serial 0 */
  SCON0  = 0x50;    /* SCON0: mode 1, 8-bit UART, enable rcvr           */
  TMOD  |= 0x20;    /* TMOD:  timer 1, mode 2, 8-bit reload             */
  TH1    = 221;     /* TH1:   reload value for 9600 baud @ 16MHz        */
  TR1    = 1;       /* TR1:   timer 1 run                               */
  TI0    = 1;       /* TI0:   set TI to send first char of UART         */

  P0MDIN &= !0x01;  /* Set pin P0.0 as analog input                     */
  REF0CN  = 0x0A;   /* Set voltage reference to "internal"              */
  ADC0CF  = 0xF9;   /* Set analog amp gain to 1.0                       */
  AMX0SL  = 0xF0;   /* Set MUX to pin 0, single ended                   */
  AD0EN   = 1;      /* Set AD1EN to activate the ADC                    */

/* Start first sample */ 
   AD0INT = 0;      /* Clear AD0INT flag                                */
   AD0BUSY = 1;     /* Set AD0BUSY flag, this starts conversion         */

  while(1)
  {
    if(AD0INT)
    {
      //printf ("ADC0 Count %4u = %01u.%04u Volts\r",
      //  (unsigned) ADC0,
      //  (unsigned) (ADC0 * V_REF) >> 8,                        /* Output Integer Portion */
      //  (unsigned) ((ADC0 * V_REF * 10000UL) >> 8UL) % 10000); /* Output Decimal Portion */      
      AD0INT = 0;    /* Clear AD0INT flag                         */
      AD0BUSY = 1;   /* Set AD0BUSY flag, this starts conversion  */
    }
  }
}
